# Rhubarb - The Funky Sweet Python ORM built on Strawberry GraphQL That's Totally Awesome

Rhubarb is an experimental ORM baked from scratch focused on automatic optimizations with Postgres data using GQL.

<img width="653" alt="Screenshot 2023-05-03 at 2 32 48 AM" src="https://user-images.githubusercontent.com/496914/235881083-f47d21ff-2462-46f9-acc2-e900316fe05f.png">

*Strawberry-Rhubarb Pie... Tasty!*

# Rhubarb at a glance

* Asyncio Native
* Build SQL functions with Python
* Built on GraphQL for optimization layer on nested queries
* Migrations - Automatically generate Schema changes as your data model updates.
* Intuitively Solve N+1 without even realizing it
* Simplify Aggregations / Joins / Subqueries
* Heavily inspired by Django and built with the philosophy of take the best parts.
* Native Public / Private Schema dichotomy
* Pass User and Extra info to use in queries through Strawberry Info's context.
* Doesn't use any other Python ORM for DB access, only Psycopg3

# Extra Rhubarb Features

Rhubarb comes with some extra integrations to make using the ORM easy...

* HTTP - FastAPI / Starlette
* Redis - Rate Limiting / Caching
* Auth - Impersonate / Sessions / Users / WebAuthN / Password
* Security - CORS / CSRF / TrustedHostNames / Auth Rate Limits
* Auditing - Record all Mutations / Queries / Subscriptions / Custom Events

## Package Status

This is an experimental package for researching new ways in Python to interact with Postgres and build apps. Take care.

## Researched by GetDynasty

This package was created with the help of research resources provided by [Dynasty Living Trusts](https://www.getdynasty.com?utm_source=github). GetDynasty is the only online platform that offers instant Living Trust Creation. GetDynasty is not actively involved in the maintenance or development of this project.